%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Copyright (c) Masahiro Sakai, 2001.
%
% 	Masahiro Sakai                  <s01397ms@sfc.keio.ac.jp>
%  
%  Redistribution and use in source and binary forms, with or without
%  modification, are permitted provided that the following conditions
%  are met:
%  
%  1. Redistributions of source code must retain the above copyright
%     notice, this list of conditions and the following disclaimer as
%     the first lines of this file unmodified.
%  2. Redistributions in binary form must reproduce the above copyright
%     notice, this list of conditions and the following disclaimer in the
%     documentation and/or other materials provided with the distribution.
%  
%  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
%  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
%  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
%  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
%  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
%  NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
%  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
%  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
%  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
%  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% $B;29M;qNA(B:
%   http://www.w3.org/TR/REC-xml
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% $B:G>e0L$N%$%s%?!<%U%'!<%9(B
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

xml_document(X, Y) :- xml_document(X, Y, []).

xml_document( xml_document(X, Y, Z) ) -->
	xml_prolog(X), xml_element(Y), 'xml_Misc*'(Z).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% $BJ8>O(B
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% $BJ8;z(B

%%%%%%%%%%%%%%%%%%%%%%%%
% $BJ8;z$NHO0O(B

% $BJ8;z$O(BUCS
xml_Char(X) --> [X], { member(X, [9,0xA,0xD]) }.
xml_Char(X) --> [X], { X >= 0x20, X =< 0xD7FF }.
xml_Char(X) --> [X], { X >= 0xE000, X =< 0xFFFD }.
xml_Char(X) --> [X], { X >= 0x10000, X =< 0x10FFFF }.

'xml_Char*'([H|T]) --> xml_Char(H), 'xml_Char*'(T).
'xml_Char*'([]) --> "".

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% $B6&DL$N9=J89=@.;R(B

%%%%%%%%%%%%%%%%%%%%%%%%
% $B6uGr(B

'xml__S_Char+'([X]) -->
	[Y], { var(X), var(Y), !, X = Y, member(X, [0x20, 0x9, 0xD, 0xA]) }.
'xml__S_Char+'([H|T]) -->
	[H], { member(H, [0x20, 0x9, 0xD, 0xA]) },
	'xml__S_Char*'(T).
'xml__S_Char*'(X) --> 'xml__S_Char+'(X).
'xml__S_Char*'("") --> "".

% xml_S(" ") --> " ". % XXX: $B5UJQ49$9$k$H$-$NET9g(B
xml_S(X) --> 'xml__S_Char+'(X).
xml_S --> xml_S(_).

'xml_S?' --> "".
'xml_S?' --> xml_S.

%%%%%%%%%%%%%%%%%%%%%%%%
% $BL>A0$H%H!<%/%s(B

xml_NameChar(X) --> xml_Letter(X).
xml_NameChar(X) --> xml_Digit(X).
xml_NameChar(X) --> [X], { member(X, ".-_:") }.
xml_NameChar(X) --> xml_CombiningChar(X).
xml_NameChar(X) --> xml_Extender(X).

'xml__NameChar*'([H|T]) --> xml_NameChar(H), 'xml__NameChar*'(T).
'xml__NameChar*'([]) --> "".

xml_Name([H|T]) -->
	(xml_Letter(H); [H], {member(H, "_:")}),
	'xml__NameChar*'(T).

'xml__pair_of_S_and_Name*'([NAME|NAMES]) -->
	xml_S, xml_Name(NAME),
	'xml__pair_of_S_and_Name*'(NAMES).
'xml__pair_of_S_and_Name*'([]) --> "".

xml_Names( xml_Names([NAME|NAMES]) ) -->
	xml_Name(NAME),
	'xml__pair_of_S_and_Name*'(NAMES).

xml_Nmtoken(S) --> 'xml__NameChar*'(S), { \+(S = "") }.

'xml__pair_of_Nmtoken_and_S*'([TOKEN|TOKENS]) -->
	xml_S, xml_Nmtoken(TOKEN),
	'xml__pair_of_Nmtoken_and_S*'(_, TOKENS).
'xml__pair_of_Nmtoken_and_S*'([]) --> "".

xml_Nmtokens([H|T]) -->
	xml_Nmtoken(H),
	'xml__pair_of_Nmtoken_and_S*'(T).

%%%%%%%%%%%%%%%%%%%%%%%%
% $B%j%F%i%k(B

xml__EntityValue_body([H|T]) -->
	([H], {\+( member(H, "%&") )};
	 xml_PEReference(H);
	 xml_Reference(H)),
	 xml__EntityValue_body(T).
xml__EntityValue_body([]) --> "".

xml_EntityValue( V ) -->
	{ member(Q, "\"'") },
	[Q], xml__EntityValue_body(V), [Q].

xml__AttValue_body([H|T], Q) -->
	([H], { \+(member(H, "%&")), \+(H=Q) }; % FIXME?
         xml_Reference(H)),
	xml__AttValue_body(T, Q).
xml__AttValue_body([], _) --> "".

xml_AttValue( V ) -->
	{ member(Q, "\"'") },
	[Q], xml__AttValue_body(V, Q), [Q].

xml_SystemLiteral( X ) -->
	{ member(Q, "\"'") },
	[Q], 'char_except*'(X, [Q]), [Q].

xml_PubidLiteral( X ) -->
	{ member(Q, "\"'") },
	[Q], 'xml_PubidChar*'(X), [Q],
	{ \+(search("'", X)) }.

xml_PubidChar(X) --> [X], { member(X, "abcdefghijklmnopqrstuwxyzABCDEFGHIJKLMNOPQRSTUWXYZ0123456789-'()+,./:=?;!*#@$_%") }.
xml_PubidChar(X) --> [X], { member(X, [0x20, 0xD, 0xA]) }.

'xml_PubidChar*'([H|T]) -->
	xml_PubidChar(H),
	'xml_PubidChar*'(T).
'xml_PubidChar*'([]) --> "".

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% $BJ8;z%G!<%?$H%^!<%/%"%C%W(B

%%%%%%%%%%%%%%%%%%%%%%%%
% $BJ8;z%G!<%?(B

% xml_CharData(X,_,_) :- write('CharData('), write(X), write(')'), nl, fail.

xml_CharData(X) -->
	'char_except*'(X, "<>&"),
	{ \+( search("]]>", X) ) }.

%%%%%%%%%%%%%%%%%%%%%%%%
% $B%3%a%s%H(B

xml_Comment( xml_Comment(X) ) --> "<!--", 'xml__comment_body_item*'(X), "-->".

xml__comment_body_item(X) --> xml_Char(X), { \+([X] = "-") }.
xml__comment_body_item(Y) -->
	"-", xml_Char(X),
	{ \+([X] = "-"), append("-", [X], Y) }.

'xml__comment_body_item*'([H|T]) -->
	xml__comment_body_item(H),
	'xml__comment_body_item*'(T).
'xml__comment_body_item*'([]) --> "".

%%%%%%%%%%%%%%%%%%%%%%%%
% $B=hM}L?Na(B

xml_PI( xml_PI(T, B) ) --> "<?", xml_PITarget(T), xml__PI_body(B), "?>".

xml__PI_body(S) -->
	xml_S, 'xml_Char*'(S),
	{ \+( search("?>", S) ) }.
xml__PI_body([]) --> "".

xml_PITarget( xml_PITarget(X) ) --> xml_Name(X),
	{ X = [X1, X2, X3 | _],
	  (\+(member(X1, "Xx"));
	   \+(member(X2, "Mm"));
           \+(member(X3, "Ll"))) }.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% CDATA$B%;%/%7%g%s(B

xml_CDSect( xml_CDSect(X) ) --> xml_CDStart, xml_CData(X), xml_CDEnd.

xml_CDStart --> "<![CDATA[".
xml_CDEnd   --> "]]>".

xml_CData(X) --> 'xml_Char*'(X), { \+( search("]]>", X) )}.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% $BA0=q$-5Z$SJ8=q7?@k8@(B

%%%%%%%%%%%%%%%%%%%%%%%%
% $BA0=q$-(B

xml_prolog( xml_prolog(X, M1, Y, M2) ) -->
	(xml_XMLDecl(X); {X = ""} ),
	'xml_Misc*'(M1), 
	(xml_doctypedecl(Y); {Y = ""}),
	'xml_Misc*'(M2).

xml_XMLDecl( [V, E, S] ) -->
	"<?xml",
	xml_VersionInfo(V),
	( {E = ""}; xml_EncodingDecl(E) ),
	( {S = ""}; xml_SDDecl(S) ),
	'xml_S?',
	"?>".

xml_VersionInfo(V) -->
	xml_S, "version", xml_Eq,
	{ member(Q, "\"'") },
	[Q], xml_VersionNum(V), [Q],
	{ \+(V = "") }.

xml_Eq --> 'xml_S?', "=", 'xml_S?'.

xml_VersionNum([H|T]) --> xml__VersionNum_Char(H), xml_VersionNum(T).
xml_VersionNum([]) --> "".

xml__VersionNum_Char(X) -->
	[X], { member(X, "abcdefghijklmnopqrstuwxyzABCDEFGHIJKLMNOPQRSTUWXYZ0123456789_.:-") }.

'xml_Misc*'([H|T]) --> xml_Misc(H), 'xml_Misc*'(T).
'xml_Misc*'([]) --> "".

xml_Misc(X) --> xml_Comment(X); xml_PI(X); xml_S(X).

%%%%%%%%%%%%%%%%%%%%%%%%
% $BJ8=q7?Dj5A(B

xml_doctypedecl( [NAME, X, Y] ) -->
	"<!DOCTYPE", xml_S, xml_Name(NAME),
	(xml_S, xml_ExternalID(X); {X = ""}),
	'xml_S?',
	% FIXME
	("[", 'xml__doctypedecl_opt2_item*'(Y), "]", 'xml_S?'; {Y = ""}),
	">".

xml__doctypedecl_opt2_item(X) --> xml_markupdecl(X).
xml__doctypedecl_opt2_item(X) --> xml_PEReference(X).
xml__doctypedecl_opt2_item(X) --> xml_S(X).
'xml__doctypedecl_opt2_item*'([H|T]) -->
	xml__doctypedecl_opt2_item(H),
	'xml__doctypedecl_opt2_item*'(T).
'xml__doctypedecl_opt2_item*'([]) --> "".

xml_markupdecl( xml_markupdecl(X) ) --> xml_element_decl(X).
xml_markupdecl( xml_markupdecl(X) ) --> xml_attlist_decl(X).
xml_markupdecl( xml_markupdecl(X) ) --> xml_entity_decl(X).
xml_entity_decl( xml_entity_decl(X) ) --> xml_notation_decl(X).
xml_entity_decl( xml_entity_decl(X) ) --> xml_PI(X).
xml_entity_decl( xml_entity_decl(X) ) --> xml_Comment(X).


%%%%%%%%%%%%%%%%%%%%%%%%
% $B30It%5%V%;%C%H(B

xml_extSubset( xml_extSubset(X, Y) ) -->
	(xml_TextDecl(X); {X = ""}),
	xml_extSubsetDecl(Y).
xml_extSubsetDecl( xml_extSubsetDecl(X) ) --> 'xml_extSubsetDecl_item*'(X).

'xml_extSubsetDecl_item*'([H|T]) -->
	xml__extSubsetDecl_item(H),
	xml_extSubsetDecl(T).
'xml_extSubsetDecl_item*'([]) --> "".

xml__extSubsetDecl_item(X) --> xml_markupdecl(X).
xml__extSubsetDecl_item(X) --> xml_conditional_sect(X).
xml__extSubsetDecl_item(X) --> xml_PEReference(X).
xml__extSubsetDecl_item(X) --> xml_S(X).

%%%%%%%%%%%%%%%%%%%%%%%%
% $B%9%?%s%I%"%m%sJ8=q@k8@(B

xml_SDDecl(X) -->
	xml_S, "standalone", xml_Eq,
	{ member(Q, "'\"")},
	[Q], xml__SDDecl_val(X), [Q].

xml__SDDecl_val(yes) --> "yes".
xml__SDDecl_val(no) --> "no".

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% $B8@8l4D6-(B

xml_LanguageID( xml_LanguageID(X, Y) ) -->
	xml_Langcode(X), xml__LanguageID_opt(Y).

xml__LanguageID_item(X) --> "-", xml_SubCode(X).
xml__LanguageID_opt(Z) -->
	xml__LanguageID_item(X), xml__LanguageID_opt(Y),
	{ append(X, Y, Z) }.
xml__LanguageID_opt([]) --> "".

xml_Langcode(X) --> xml_ISO639Code(X).
xml_Langcode(X) --> xml_IanaCode(X).
xml_Langcode(X) --> xml_UserCode(X).

xml_ISO639Code([A, B]) --> xml__ISO639Code_Char(A), xml__ISO639Code_Char(B).

xml__ISO639Code_Char(X) --> [X], { member(X, "abcdefghijklmnopqrstuwxyzABCDEFGHIJKLMNOPQRSTUWXYZ") }.

xml_IanaCode([H, T]) --> [H], { member(H, "iI") }, "-", xml_Subcode(T).
xml_UserCode([H, T]) --> [H], { member(H, "xX") }, "-", xml_Subcode(T).

xml_Subcode([H|T]) --> xml__Subcode_Char(H), xml_Subcode(T).
xml_Subcode([X]) --> xml__Subcode_Char(X).

xml__Subcode_Char(X) --> [X], { member(X, "abcdefghijklmnopqrstuwxyzABCDEFGHIJKLMNOPQRSTUWXYZ") }.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% $BO@M}9=B$(B
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%
% $BMWAG(B

xml_element( xml_element(Name, Attrs, []) ) -->
	xml_EmptyElemTag(Name, Attrs).
xml_element( xml_element(Name, Attrs, C) ) -->
	xml_STag(Name, Attrs), xml_content(C), xml_ETag(Name).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% $B3+;O%?%0!"=*N;%?%05Z$S6uMWAG%?%0(B

%%%%%%%%%%%%%%%%%%%%%%%%
% $B3+;O%?%0(B

xml_STag(Name, Attrs) -->
	"<", xml_Name(Name),
	'xml__pair_of_S_and_Attribute*'(Attrs),
	'xml_S?', ">".

xml__pair_of_S_and_Attribute(X) --> xml_S, xml_Attribute(X).
'xml__pair_of_S_and_Attribute*'([H|T]) -->
	xml_S, xml_Attribute(H),
	'xml__pair_of_S_and_Attribute*'(T).
'xml__pair_of_S_and_Attribute*'([]) --> "".

xml_Attribute( [Name, Value] ) -->
	xml_Name(Name), xml_Eq, xml_AttValue(Value).

%%%%%%%%%%%%%%%%%%%%%%%%
% $B=*N;%?%0(B

xml_ETag(Name) --> "</", xml_Name(Name), 'xml_S?', ">".

%%%%%%%%%%%%%%%%%%%%%%%%
% $B%3%s%F%s%s%H(B

% FIXME: $BO"B3$9$k(Bxml_CharData$B$rG'$a$J$$$h$&$K$9$k(B?
xml_content([H|T]) --> xml__content_item(H), xml_content(T).
xml_content([]) --> "".

xml__content_item(X) --> xml_element(X).
xml__content_item(X) --> xml_CharData(X), { \+(X = "") }.
xml__content_item(X) --> xml_Reference(X).
xml__content_item(X) --> xml_CDSect(X).
xml__content_item(X) --> xml_PI(X).
xml__content_item(X) --> xml_Comment(X).

%%%%%%%%%%%%%%%%%%%%%%%%
% $B6uMWAG$N$?$a$N%?%0(B

xml_EmptyElemTag(Name, Attrs) -->
	"<", xml_Name(Name),
	'xml__pair_of_S_and_Attribute*'(Attrs),
	'xml_S?', "/>".

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% $BMWAG7?@k8@(B

%%%%%%%%%%%%%%%%%%%%%%%%
% $BMWAG7?@k8@(B

xml_elementdecl( xml_elementdecl(Name, Spec) ) -->
	"<!ELEMENT", xml_S, xml_Name(Name), xml_S,
	xml_contentspec(Spec), 'xml_S?', ">".

xml_contentspec("EMPTY") --> "EMPTY".
xml_contentspec("ANY") --> "ANY".
xml_contentspec(X) --> xml_Mixed(X).
xml_contentspec(X) --> xml_children(X).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% $BMWAGFbMF(B

%%%%%%%%%%%%%%%%%%%%%%%%
% $BMWAGFbMF%b%G%k(B

xml_children( xml_children(A, B) ) -->
	(xml_choice(A); xml_seq(A)),
	([B], { member(B, "?*+") }; B = []).

xml_cp( xml_cp(X, Y) ) --> xml_Name(X), xml__cp_postfix(Y).
xml_cp( xml_cp(X, Y) ) --> xml_choice(X), xml__cp_postfix(Y).
xml_cp( xml_cp(X, Y) ) --> xml_seq(X), xml__cp_postfix(Y).
xml__cp_postfix([]).
xml__cp_postfix(X) --> [X], { member(X, "?*+") }.


xml_choice( xml_choice(X, Y) ) -->
	"(", 'xml_S?', cp(X),
	'xml__choice_item*'(Y),
	'xml_S?', ")".

xml__choice_item(X) --> 'xml_S?', "|", 'xml_S?', xml_cp(X).
'xml__choice_item*'([H|T]) --> xml__choice_item(H), 'xml__choice_item*'(T).
'xml__choice_item*'([]) --> "".

xml_seq( xml_choice(X, Y) ) -->
	"(", 'xml_S?', cp(X),
	'xml__seq_item*'(Y),
	'xml_S?', ")".

xml__seq_item(X) --> 'xml_S?', ",", 'xml_S?', xml_cp(X).
'xml__seq_item*'([H|T]) --> xml__seq_item(H), 'xml__seq_item*'(T).
'xml__seq_item*'([]) --> "".

%%%%%%%%%%%%%%%%%%%%%%%%
% $B:.9gFbMF@k8@(B

xml_Mixed( xml_Mixed(X) ) -->
	"(", 'xml_S?', "#PCDATA", 'xml__Mixed_item*'(X), 'xml_S?', ")".
xml_Mixed( xml_Mixed([]) ) -->
	"(", 'xml_S?', "#PCDATA", 'xml_S?', ")".

xml__Mixed_item([]) --> 'xml_S?'.
xml__Mixed_item(Name) --> 'xml_S?', xml_Name(Name).
'xml__Mixed_item*'([H|T]) --> xml__Mixed_item(H), 'xml__Mixed_item*'(T).
'xml__Mixed_item*'([])    --> "".

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% $BB0@-%j%9%H(B


%%%%%%%%%%%%%%%%%%%%%%%%
% $BB0@-%j%9%H@k8@(B

xml_AttlistDecl( xml_AttlistDecl(Name, Defs) ) -->
	"<!ATTLIST", xml_S, xml_Name(Name), 'xml_AttDef*'(Defs),
	'xml_S?', ">".

xml_AttDef( xml_AttDef(Name, Type, Default) ) -->
	xml_S, xml_Name(Name),
	xml_S, xml_AttType(Type),
	xml_S, xml_DefaultDecl(Default).

'xml_AttDef*'([H|T]) --> xml_AttDef(H), 'xml_AttDef*'(T).
'xml_AttDef*'([]) --> "".

xml_AttType( xml_AttType(X) ) --> xml_StringType(X).
xml_AttType( xml_AttType(X) ) --> xml_TokenizedType(X).
xml_AttType( xml_EnumerableType(X) ) --> xml_EnumerableType(X).

xml_StringType( xml_StringType("CDATA") ) --> "CDATA".

xml_TokenizedType( xml_TokenizedType("ID") )       --> "ID".
xml_TokenizedType( xml_TokenizedType("IDREF") )    --> "IDREF".
xml_TokenizedType( xml_TokenizedType("IDREFS") )   --> "IDREFS".
xml_TokenizedType( xml_TokenizedType("ENTITY") )   --> "ENTITY".
xml_TokenizedType( xml_TokenizedType("ENTITIES") ) --> "ENTITIES".
xml_TokenizedType( xml_TokenizedType("NMTOKEN") )  --> "NMTOKEN".
xml_TokenizedType( xml_TokenizedType("NMTOKENS") ) --> "NMTOKENS".

%%%%%%%%%%%%%%%%%%%%%%%%
% $BNs5sB0@-$N7?(B

xml_EnumerableType( xml_EnumerableType(X) ) --> xml_NotationType(X).
xml_EnumerableType( xml_Enumeration(X) ) --> xml_Enumeration(X).

xml_NotationType( xml_NotationType([Name|Names]) ) -->
	"NOTATION", xml_S,
	"(", 'xml_S?', xml_Name(Name), 'xml__NotationType_item*'(Names),
	'xml_S?', ")".

xml__NotationType_item(Name) --> 'xml_S?', "|", 'xml_S?', xml_Name(Name).
'xml__NotationType_item*'([H|T]) -->
	xml__NotationType_item(H),
	'xml__NotationType_item*'(T).
'xml__NotationType_item*'([]) --> "".


xml_Enumeration( xml_Enumeration( [Token|Tokens] ) ) -->
	"(", 'xml_S?', xml_Nmtoken(Token), 'xml__Enumeration_item*'(Tokens),
	'xml_S?', ")".

'xml__Enumeration_item*'([H|T]) -->
	'xml_S?', "|", 'xml_S?', xml_Nmtoken(H),
	'xml__Enumeration_item*'(T).
'xml__Enumeration_item*'([]) --> "".


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% $BB0@-$N%G%U%)%k%H(B

%%%%%%%%%%%%%%%%%%%%%%%%
% $BB0@-$N%G%U%)%k%H(B

xml_DefaultDecl( xml_DefaultDecl("#REQUIRED") ) --> "#REQUIRED".
xml_DefaultDecl( xml_DefaultDecl("#IMPLIED") )  --> "#IMPLIED".
xml_DefaultDecl( xml_DefaultDecl("#FIXED", Value) ) -->
	xml__DefaultDecl_prefix, xml_AttValue(Value).

xml__DefaultDecl_prefix --> "#FIXED", xml_S.
xml__DefaultDecl_prefix --> "".

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% $B>r7oIU$-%;%/%7%g%s(B

%%%%%%%%%%%%%%%%%%%%%%%%
% $B>r7oIU$-%;%/%7%g%s(B

xml_conditionalSect( xml_conditionalSect(X) ) --> xml_includeSect(X).
xml_conditionalSect( xml_conditionalSect(X) ) --> xml_ignore(X).

xml_includeSect( xml_includeSect(X) ) -->
	"<![", 'xml_S?',"INCLUDE", 'xml_S?',
	"[", xml_extSubsetDecl(X), "]]>".

xml_ignoreSect( xml_ignoreSect(X) ) -->
	"<![", 'xml_S?', "IGNORE", 'xml_S?', "[",
	'xml__ignoreSectContents*'(X), "]]>".
xml_ignoreSectContents( xml_ignoreSectContents(X, Y) ) -->
	xml_Ignore(X), xml__ignoreSectContents_item*(Y).

'xml__ignoreSectContents*'([H|T]) -->
	xml_ignoreSectContents(H), 
	'xml__ignoreSectContents*'(T).
'xml__ignoreSectContents*'([]) --> "".

xml__ignoreSectContents_item([X, Y]) -->
	"<![", xml_ignoreSectContents(X), "]]>", xml_Ignore(Y).
'xml__ignoreSectContents_item*'([H|T]) -->
	xml__ignoreSectContents_item(H),
	'xml__ignoreSectContents_item*'(T).
'xml__ignoreSectContents_item*'([]) --> "".

xml_Ignore( xml_Ignore(X) ) -->
	'xml_Char*'(X), { \+( search("<![", X) ), \+( search("]]>", X) ) }.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% $BJ*M}9=B$(B
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%
% $BJ8;z;2>H(B

% FIXME

xml_CharRef( xml_CharRef(Z) ) -->
	"&#", 'xml_Digit+'(X), ";", { append(["&#", X, ";"], Z) }.
xml_CharRef( xml_CharRef(Z) ) -->
	"&#x", 'xml__HexChar+'(X), ";", { append(["&#x", X, ";"], Z) }.

xml__HexChar(X) --> [X], { member(X, "0123456789abcdefABCDEF") }.
'xml__HexChar*'([H|T]) --> xml__HexChar(H), 'xml__HexChar*'(T).
'xml__HexChar*'([]) --> "".
'xml__HexChar+'(X) --> 'xml__HexChar*'(X), { \+(X = "") }.

%%%%%%%%%%%%%%%%%%%%%%%%
% $B<BBN;2>H(B

xml_Reference( xml_Reference(X) ) --> xml_EntityRef(X).
xml_Reference( xml_Reference(X) ) --> xml_CharRef(X).

xml_EntityRef( xml_EntityRef(Name) ) --> "&", xml_Name(Name), ";".
xml_PEReference( xml_PEReference(Name) ) --> "%", xml_Name(Name), ";".

%%%%%%%%%%%%%%%%%%%%%%%%
% $B<BBN@k8@(B

xml_EntityDecl( xml_EntityDecl(X) ) --> xml_GEDecl(X).
xml_EntityDecl( xml_EntityDecl(X) ) --> xml_PEDecl(X).

xml_GEDecl( xml_GEDecl(Name, X) ) -->
	"<!ENTITY", xml_S, xml_Name(Name), xml_S,
	xml_EntityDef(X), 'xml_S?', ">".

xml_PEDecl( xml_PEDecl(Name, X) ) -->
	"<!ENTITY", xml_S, "%", xml_S, xml_Name(Name), 
        xml_S, xml_PEDef(X), 'xml_S?', ">".

xml_EntityDef( xml_EntityDef(X) ) --> xml_EntityValue(X).
xml_EntityDef( xml_EntityDef(X, Y) ) -->
	xml_ExternalID(X),
	(xml_NDataDecl?(Y); {Y = ""}).

xml_PEDef( xml_PEDef(X) ) --> xml_EntityValue(X).
xml_PEDef( xml_PEDef(X) ) --> xml_ExternalID(X).

%%%%%%%%%%%%%%%%%%%%%%%%
% $B30It<BBN@k8@(B

xml_ExternalID( xml_ExternalID(X) ) -->
	"SYSTEM", xml_S, xml_SystemLiteral(X).

xml_ExternalID( xml_ExternalID(X, Y) ) -->
	"PUBLIC", xml_S, xml_PubidLiteral(X), xml_S, xml_SystemLiteral(Y).

xml_NDataDecl( xml_NDataDecl(Name) ) -->
	xml_S, "NDATA", xml_S, xml_Name(Name).

%%%%%%%%%%%%%%%%%%%%%%%%
% $B2r@O<BBN@k8@(B

xml_TextDecl( xml_TextDecl(V, E) ) -->
	"<?xml",
	(xml_VersionInfo(V); {V = ""}),
	xml_EncodingDecl(E), 'xml_S?', "?>".

%%%%%%%%%%%%%%%%%%%%%%%%
% $B@07A<0$N2r@OBP>]<BBN(B

xml_extParsedEnt( xml_extParsedEnt(X, C) ) -->
	(xml_TextDecl(X); {X = ""}), xml_content(C).
xml_extPE( xml_extPE(X, Y) ) -->
	(xml_TextDecl(X); {X = ""}), xml_extSubsetDecl(Y).

%%%%%%%%%%%%%%%%%%%%%%%%
% $BId9f2=@k8@(B

xml_EncodingDecl(Name) -->
	xml_S, "encoding", xml_Eq,
	{ member(Q, "\"'") },
	[Q], xml_EncName(Name), [Q].

xml_EncName([H|T]) -->
	[H],
	{ member(H, "abcdefghijklmnopqrstuwxyzABCDEFGHIJKLMNOPQRSTUWXYZ") },
	xml__EncName_tail(T).

xml__EncName_tail([H|T]) -->
	[H],
	{ member(H, "abcdefghijklmnopqrstuwxyzABCDEFGHIJKLMNOPQRSTUWXYZ0123456789._-") },
	xml__EncName_tail(T).
xml__EncName_tail([]) --> "".

%%%%%%%%%%%%%%%%%%%%%%%%
% $B5-K!@k8@(B

xml_NotationDecl( xml_NotationDecl(Name, X) ) -->
	"<!NOTATION", xml_S, xml_Name(Name), xml_S,
	(xml_ExternalID(X); xml_PublicID(X)), xml_S, ">".

xml_PublicID( xml_PublicID(X) ) --> "PUBLIC", xml_S, xml_PubidLiteral(X).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% $BJ8;z%/%i%9(B
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

xml_Letter(X) --> xml_BaseChar(X); xml_Ideographic(X).


xml_BaseChar(X) --> [X], {
0x0041 =< X, X =< 0x005A;
0x0061 =< X, X =< 0x007A;
0x00C0 =< X, X =< 0x00D6;
0x00D8 =< X, X =< 0x00F6;
0x00F8 =< X, X =< 0x00FF;
0x0100 =< X, X =< 0x0131;
0x0134 =< X, X =< 0x013E;
0x0141 =< X, X =< 0x0148;
0x014A =< X, X =< 0x017E;
0x0180 =< X, X =< 0x01C3;
0x01CD =< X, X =< 0x01F0;
0x01F4 =< X, X =< 0x01F5;
0x01FA =< X, X =< 0x0217;
0x0250 =< X, X =< 0x02A8;
0x02BB =< X, X =< 0x02C1;
X = 0x0386;
0x0388 =< X, X =< 0x038A;
X = 0x038C;
0x038E =< X, X =< 0x03A1;
0x03A3 =< X, X =< 0x03CE;
0x03D0 =< X, X =< 0x03D6;
X = 0x03DA;
X = 0x03DC;
X = 0x03DE;
X = 0x03E0;
0x03E2 =< X, X =< 0x03F3;
0x0401 =< X, X =< 0x040C;
0x040E =< X, X =< 0x044F;
0x0451 =< X, X =< 0x045C;
0x045E =< X, X =< 0x0481;
0x0490 =< X, X =< 0x04C4;
0x04C7 =< X, X =< 0x04C8;
0x04CB =< X, X =< 0x04CC;
0x04D0 =< X, X =< 0x04EB;
0x04EE =< X, X =< 0x04F5;
0x04F8 =< X, X =< 0x04F9;
0x0531 =< X, X =< 0x0556;
X = 0x0559;
0x0561 =< X, X =< 0x0586;
0x05D0 =< X, X =< 0x05EA;
0x05F0 =< X, X =< 0x05F2;
0x0621 =< X, X =< 0x063A;
0x0641 =< X, X =< 0x064A;
0x0671 =< X, X =< 0x06B7;
0x06BA =< X, X =< 0x06BE;
0x06C0 =< X, X =< 0x06CE;
0x06D0 =< X, X =< 0x06D3;
X = 0x06D5;
0x06E5 =< X, X =< 0x06E6;
0x0905 =< X, X =< 0x0939;
X = 0x093D;
0x0958 =< X, X =< 0x0961;
0x0985 =< X, X =< 0x098C;
0x098F =< X, X =< 0x0990;
0x0993 =< X, X =< 0x09A8;
0x09AA =< X, X =< 0x09B0;
X = 0x09B2;
0x09B6 =< X, X =< 0x09B9;
0x09DC =< X, X =< 0x09DD;
0x09DF =< X, X =< 0x09E1;
0x09F0 =< X, X =< 0x09F1;
0x0A05 =< X, X =< 0x0A0A;
0x0A0F =< X, X =< 0x0A10;
0x0A13 =< X, X =< 0x0A28;
0x0A2A =< X, X =< 0x0A30;
0x0A32 =< X, X =< 0x0A33;
0x0A35 =< X, X =< 0x0A36;
0x0A38 =< X, X =< 0x0A39;
0x0A59 =< X, X =< 0x0A5C;
X = 0x0A5E;
0x0A72 =< X, X =< 0x0A74;
0x0A85 =< X, X =< 0x0A8B;
X = 0x0A8D;
0x0A8F =< X, X =< 0x0A91;
0x0A93 =< X, X =< 0x0AA8;
0x0AAA =< X, X =< 0x0AB0;
0x0AB2 =< X, X =< 0x0AB3;
0x0AB5 =< X, X =< 0x0AB9;
X = 0x0ABD;
X = 0x0AE0;
0x0B05 =< X, X =< 0x0B0C;
0x0B0F =< X, X =< 0x0B10;
0x0B13 =< X, X =< 0x0B28;
0x0B2A =< X, X =< 0x0B30;
0x0B32 =< X, X =< 0x0B33;
0x0B36 =< X, X =< 0x0B39;
X = 0x0B3D;
0x0B5C =< X, X =< 0x0B5D;
0x0B5F =< X, X =< 0x0B61;
0x0B85 =< X, X =< 0x0B8A;
0x0B8E =< X, X =< 0x0B90;
0x0B92 =< X, X =< 0x0B95;
0x0B99 =< X, X =< 0x0B9A;
X = 0x0B9C;
0x0B9E =< X, X =< 0x0B9F;
0x0BA3 =< X, X =< 0x0BA4;
0x0BA8 =< X, X =< 0x0BAA;
0x0BAE =< X, X =< 0x0BB5;
0x0BB7 =< X, X =< 0x0BB9;
0x0C05 =< X, X =< 0x0C0C;
0x0C0E =< X, X =< 0x0C10;
0x0C12 =< X, X =< 0x0C28;
0x0C2A =< X, X =< 0x0C33;
0x0C35 =< X, X =< 0x0C39;
0x0C60 =< X, X =< 0x0C61;
0x0C85 =< X, X =< 0x0C8C;
0x0C8E =< X, X =< 0x0C90;
0x0C92 =< X, X =< 0x0CA8;
0x0CAA =< X, X =< 0x0CB3;
0x0CB5 =< X, X =< 0x0CB9;
X = 0x0CDE;
0x0CE0 =< X, X =< 0x0CE1;
0x0D05 =< X, X =< 0x0D0C;
0x0D0E =< X, X =< 0x0D10;
0x0D12 =< X, X =< 0x0D28;
0x0D2A =< X, X =< 0x0D39;
0x0D60 =< X, X =< 0x0D61;
0x0E01 =< X, X =< 0x0E2E;
X = 0x0E30;
0x0E32 =< X, X =< 0x0E33;
0x0E40 =< X, X =< 0x0E45;
0x0E81 =< X, X =< 0x0E82;
X = 0x0E84;
0x0E87 =< X, X =< 0x0E88;
X = 0x0E8A;
X = 0x0E8D;
0x0E94 =< X, X =< 0x0E97;
0x0E99 =< X, X =< 0x0E9F;
0x0EA1 =< X, X =< 0x0EA3;
X = 0x0EA5;
X = 0x0EA7;
0x0EAA =< X, X =< 0x0EAB;
0x0EAD =< X, X =< 0x0EAE;
X = 0x0EB0;
0x0EB2 =< X, X =< 0x0EB3;
X = 0x0EBD;
0x0EC0 =< X, X =< 0x0EC4;
0x0F40 =< X, X =< 0x0F47;
0x0F49 =< X, X =< 0x0F69;
0x10A0 =< X, X =< 0x10C5;
0x10D0 =< X, X =< 0x10F6;
X = 0x1100;
0x1102 =< X, X =< 0x1103;
0x1105 =< X, X =< 0x1107;
X = 0x1109;
0x110B =< X, X =< 0x110C;
0x110E =< X, X =< 0x1112;
X = 0x113C;
X = 0x113E;
X = 0x1140;
X = 0x114C;
X = 0x114E;
X = 0x1150;
0x1154 =< X, X =< 0x1155;
X = 0x1159;
0x115F =< X, X =< 0x1161;
X = 0x1163;
X = 0x1165;
X = 0x1167;
X = 0x1169;
0x116D =< X, X =< 0x116E;
0x1172 =< X, X =< 0x1173;
X = 0x1175;
X = 0x119E;
X = 0x11A8;
X = 0x11AB;
0x11AE =< X, X =< 0x11AF;
0x11B7 =< X, X =< 0x11B8;
X = 0x11BA;
0x11BC =< X, X =< 0x11C2;
X = 0x11EB;
X = 0x11F0;
X = 0x11F9;
0x1E00 =< X, X =< 0x1E9B;
0x1EA0 =< X, X =< 0x1EF9;
0x1F00 =< X, X =< 0x1F15;
0x1F18 =< X, X =< 0x1F1D;
0x1F20 =< X, X =< 0x1F45;
0x1F48 =< X, X =< 0x1F4D;
0x1F50 =< X, X =< 0x1F57;
X = 0x1F59;
X = 0x1F5B;
X = 0x1F5D;
0x1F5F =< X, X =< 0x1F7D;
0x1F80 =< X, X =< 0x1FB4;
0x1FB6 =< X, X =< 0x1FBC;
X = 0x1FBE;
0x1FC2 =< X, X =< 0x1FC4;
0x1FC6 =< X, X =< 0x1FCC;
0x1FD0 =< X, X =< 0x1FD3;
0x1FD6 =< X, X =< 0x1FDB;
0x1FE0 =< X, X =< 0x1FEC;
0x1FF2 =< X, X =< 0x1FF4;
0x1FF6 =< X, X =< 0x1FFC;
X = 0x2126;
0x212A =< X, X =< 0x212B;
X = 0x212E;
0x2180 =< X, X =< 0x2182;
0x3041 =< X, X =< 0x3094;
0x30A1 =< X, X =< 0x30FA;
0x3105 =< X, X =< 0x312C;
0xAC00 =< X, X =< 0xD7A3
}. % xml_BaseChar


xml_Ideographic(X) --> [X], {
0x4E00 =< X, X =< 0x9FA5;
X = 0x3007;
0x3021 =< X, X =< 0x3029 
}. % xml_Ideographic


xml_CombiningChar(X) --> [X], {
0x0300 =< X, X =< 0x0345;
0x0360 =< X, X =< 0x0361;
0x0483 =< X, X =< 0x0486;
0x0591 =< X, X =< 0x05A1;
0x05A3 =< X, X =< 0x05B9;
0x05BB =< X, X =< 0x05BD;
X = 0x05BF;
0x05C1 =< X, X =< 0x05C2;
X = 0x05C4;
0x064B =< X, X =< 0x0652;
X = 0x0670;
0x06D6 =< X, X =< 0x06DC;
0x06DD =< X, X =< 0x06DF;
0x06E0 =< X, X =< 0x06E4;
0x06E7 =< X, X =< 0x06E8;
0x06EA =< X, X =< 0x06ED;
0x0901 =< X, X =< 0x0903;
X = 0x093C;
0x093E =< X, X =< 0x094C;
X = 0x094D;
0x0951 =< X, X =< 0x0954;
0x0962 =< X, X =< 0x0963;
0x0981 =< X, X =< 0x0983;
X = 0x09BC;
X = 0x09BE;
X = 0x09BF;
0x09C0 =< X, X =< 0x09C4;
0x09C7 =< X, X =< 0x09C8;
0x09CB =< X, X =< 0x09CD;
X = 0x09D7;
0x09E2 =< X, X =< 0x09E3;
X = 0x0A02;
X = 0x0A3C;
X = 0x0A3E;
X = 0x0A3F;
0x0A40 =< X, X =< 0x0A42;
0x0A47 =< X, X =< 0x0A48;
0x0A4B =< X, X =< 0x0A4D;
0x0A70 =< X, X =< 0x0A71;
0x0A81 =< X, X =< 0x0A83;
X = 0x0ABC;
0x0ABE =< X, X =< 0x0AC5;
0x0AC7 =< X, X =< 0x0AC9;
0x0ACB =< X, X =< 0x0ACD;
0x0B01 =< X, X =< 0x0B03;
X = 0x0B3C;
0x0B3E =< X, X =< 0x0B43;
0x0B47 =< X, X =< 0x0B48;
0x0B4B =< X, X =< 0x0B4D;
0x0B56 =< X, X =< 0x0B57;
0x0B82 =< X, X =< 0x0B83;
0x0BBE =< X, X =< 0x0BC2;
0x0BC6 =< X, X =< 0x0BC8;
0x0BCA =< X, X =< 0x0BCD;
X = 0x0BD7;
0x0C01 =< X, X =< 0x0C03;
0x0C3E =< X, X =< 0x0C44;
0x0C46 =< X, X =< 0x0C48;
0x0C4A =< X, X =< 0x0C4D;
0x0C55 =< X, X =< 0x0C56;
0x0C82 =< X, X =< 0x0C83;
0x0CBE =< X, X =< 0x0CC4;
0x0CC6 =< X, X =< 0x0CC8;
0x0CCA =< X, X =< 0x0CCD;
0x0CD5 =< X, X =< 0x0CD6;
0x0D02 =< X, X =< 0x0D03;
0x0D3E =< X, X =< 0x0D43;
0x0D46 =< X, X =< 0x0D48;
0x0D4A =< X, X =< 0x0D4D;
X = 0x0D57;
X = 0x0E31;
0x0E34 =< X, X =< 0x0E3A;
0x0E47 =< X, X =< 0x0E4E;
X = 0x0EB1;
0x0EB4 =< X, X =< 0x0EB9;
0x0EBB =< X, X =< 0x0EBC;
0x0EC8 =< X, X =< 0x0ECD;
0x0F18 =< X, X =< 0x0F19;
X = 0x0F35;
X = 0x0F37;
X = 0x0F39;
X = 0x0F3E;
X = 0x0F3F;
0x0F71 =< X, X =< 0x0F84;
0x0F86 =< X, X =< 0x0F8B;
0x0F90 =< X, X =< 0x0F95;
X = 0x0F97;
0x0F99 =< X, X =< 0x0FAD;
0x0FB1 =< X, X =< 0x0FB7;
X = 0x0FB9;
0x20D0 =< X, X =< 0x20DC;
X = 0x20E1;
0x302A =< X, X =< 0x302F;
X = 0x3099;
X = 0x309A
}. % xml_CombiningChar


xml_Digit(X) --> [X], { 
0x0030 =< X, X =< 0x0039;
0x0660 =< X, X =< 0x0669;
0x06F0 =< X, X =< 0x06F9;
0x0966 =< X, X =< 0x096F;
0x09E6 =< X, X =< 0x09EF;
0x0A66 =< X, X =< 0x0A6F;
0x0AE6 =< X, X =< 0x0AEF;
0x0B66 =< X, X =< 0x0B6F;
0x0BE7 =< X, X =< 0x0BEF;
0x0C66 =< X, X =< 0x0C6F;
0x0CE6 =< X, X =< 0x0CEF;
0x0D66 =< X, X =< 0x0D6F;
0x0E50 =< X, X =< 0x0E59;
0x0ED0 =< X, X =< 0x0ED9;
0x0F20 =< X, X =< 0x0F29
}. % xml_Digit


xml_Extender(X) --> [X], {
X = 0x00B7;
X = 0x02D0;
X = 0x02D1;
X = 0x0387;
X = 0x0640;
X = 0x0E46;
X = 0x0EC6;
X = 0x3005;
0x3031 =< X, X =< 0x3035;
0x309D =< X, X =< 0x309E;
0x30FC =< X, X =< 0x30FE
}. % xml_Extender

'xml_Digit+'(X) --> 'xml_Digit*'(X), { \+(X = []) }.
'xml_Digit*'([H|T]) --> xml_Digit(H), 'xml_Digit*'(T).
'xml_Digit*'([]) --> "".

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% $B%f!<%F%#%j%F%#(B
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

head([], _).
head([H|T1], [H|T2]) :- head(T1, T2).

search(X, Y) :- head(X, Y).
search(X, [_|T]) :- search(X, T).

char_except(X, E) --> [X], { \+(member(X, E)) }.
'char_except*'([H|T], E) --> char_except(H, E), 'char_except*'(T, E).
'char_except*'([], _) --> "".

% $B%G%P%C%0MQ(B

write_string(STR) :-
	name(Atom, STR), write(Atom), nl.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
